# -*- coding: utf-8 -*-
##############################################################################
#
#    Copyright (C) 2015 Lorenzo Battistini <lorenzo.battistini@agilebg.com>
#    Copyright (C) 2018 Gianmarco Conte    <gconte@dinamicheaziendali.it>
#    Copyright (C) 2018 Marco Calcagni     <mcalcagni@dinamicheaziendali.it>
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as published
#    by the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from openerp import models, exceptions, _


class AccountTax(models.Model):
    _inherit = 'account.tax'

    def get_tax_by_invoice_tax(self, invoice_tax):
        tax_ids = []
        if ' - ' in invoice_tax:
            tax_descr = invoice_tax.split(' - ')[0]
            tax_ids = self.search([('description', '=', tax_descr)])
        if not tax_ids or len(tax_ids) > 1:
            tax_ids = self.search([('name', '=', invoice_tax)])
        if not tax_ids:
            raise exceptions.Warning(
                _('Error'), _('No tax %s found') % invoice_tax)
        elif len(tax_ids) > 1:
            raise exceptions.Warning(
                _('Error'), _('Too many tax %s found') % invoice_tax)
        return tax_ids[0]
